Inhalte

# Dienst SFDialogs.Dialog

Der Dienst Dialog trägt zur Verwaltung von Dialogen bei, die mit dem Dialogeditor Basic erstellt wurden, oder von Dialogen, die im laufenden Betrieb erstellt wurden. Jede Instanz der aktuellen Klasse stellt einen einzelnen Dialog dar, der dem Benutzer angezeigt wird.

Der Dialog kann im modalen oder im nicht-modalen Modus angezeigt werden.

Im modalen Modus wird das Feld angezeigt und die Ausführung des Makroprozesses ausgesetzt, bis eine der Schaltflächen „OK“ oder „Abbrechen“ gedrückt wird. In der Zwischenzeit können auf der Box ausgeführte Benutzeraktionen bestimmte Aktionen auslösen.

Im nicht-modalen Modus „schwebt“ der Dialog auf dem Desktop des Benutzers und die Ausführung des Makroprozesses wird normal fortgesetzt. Der nicht-modale Dialog wird geschlossen, wenn er mit der Methode Terminate() beendet wird oder wenn die LibreOffice-Sitzung endet. Die Schaltfläche zum Schließen des Fensters ist in nicht-modalen Dialogen inaktiv.

Der Dialog verschwindet nach seiner expliziten Beendigung aus dem Speicher.

Der Dienst SFDialogs.Dialog ist eng mit dem Dienst SFDialogs.DialogControl verwandt.

## Dienstaufruf und Nutzung

Vor der Verwendung des Dienstes Dialog muss die Bibliothek ScriptForge geladen oder importiert werden:

• Grundlegende Makros erfordern das Laden der Bibliothek ScriptForge mit der folgenden Anweisung:
GlobalScope.BasicLibraries.loadLibrary("ScriptForge")
• Python-Skripte erfordern einen Import aus dem Modul scriptforge:
from scriptforge import CreateScriptService

Der Dienst Dialog wird über die Methode CreateScriptService aufgerufen. Er erfordert drei zusätzliche Positionsargumente, um den zu aktivierende Dialog anzugeben:

Container: "GlobalScope" für vorinstallierte Bibliotheken oder ein Fenstername wie vom Dienst ScriptForge.UI definiert. Der Standardwert leere Zeichenfolge "" steht für das aktuelle Dokument.

Library: Der Name einer im Container enthaltenen Bibliothek, bei der die Groß-/Kleinschreibung beachtet wird. Der Standardwert ist "Standard".

DialogName: Eine Zeichenfolge mit Berücksichtigung der Groß-/Kleinschreibung, die den Dialog bezeichnet.

Die folgenden Beispiele in Basic und Python zeigen den Dialog dlgConsole, der zur gemeinsam genutzten Bibliothek ScriptForge gehört:

          Dim oDlg As Object, lButton As Long
          Dim Container As String, Library As String, DialogName As String
          Set oDlg = CreateScriptService("SFDialogs.Dialog", "GlobalScope", "ScriptForge", "dlgConsole")
          ' … Steuerungsinitialisierung startet hier …
          lButton = oDlg.Execute()
          ' Standardmodus = Modal
          If lButton = oDlg.OKBUTTON Then
          ' … Prozesskontrollen und erledigen, was hier nötig ist
          End If
          oDlg.Terminate()

Oder mit Python:

        dlg = CreateScriptService('SFDialogs.Dialog', 'GlobalScope', 'ScriptForge', 'dlgConsole')
        # … Steuerungsinitialisierung startet hier …
        rc = dlg.Execute()
        # Standardmodus ist Modal
        if rc == dlg.OKBUTTON:
            # … Prozesskontrollen und erledigen, was hier nötig ist
        dlg.Terminate()

Verwenden Sie die Zeichenfolge "GlobalScope" als Argument container, wenn der Dialog entweder in Meine Makros und Dialoge oder in Anwendungsmakros und -dialoge gespeichert ist.

Der Dialogdienst bietet Methoden, die neue Steuerelemente dynamisch in einem vorhandenen Dialog erstellen, der mit dem Dialogeditor vordefiniert wurde. Ein Dialog wird mit Steuerelementen im Dialogeditor initialisiert und neue Steuerelemente können zur Laufzeit vor oder nach der Dialog-Anweisung Execute() hinzugefügt werden.

Der Dienst Dialog kann auch über die Methode CreateScriptService aufgerufen werden, wenn Dialoge im laufenden Betrieb erstellt werden. Es sind zwei zusätzliche Positionsargumente nach dem Namen des Ad-hoc-Dienstes "NewDialog" erforderlich:

DialogName: Eine Zeichenfolge mit Berücksichtigung der Groß-/Kleinschreibung, die den Dialog bezeichnet.

Place: Fensterposition des Dialogs, entweder:

- eine Matrix in Basic oder ein Tupel in Python mit 4 Elementen: (X, Y, Breite, Höhe)

- ein Objekt com.sun.star.awt.Rectangle [X, Y, Breite, Höhe]

Alle Elemente werden in Einheiten Map AppFont ausgedrückt.

        Sub newDialog()
            Dim oDlg As Object
           oDlg = CreateScriptService("NewDialog", "myDialog1", Array(100,200, 40, 110))
           ' ...
        End Sub

Oder mit Python:

        def newDialog():
           dlg = CreateScriptService('NeuerDialog', 'meinDialog1', (100, 200, 40, 110))
           # … Prozesskontrollen und erledigen, was nötig ist

Für solche neuen Dialoge stehen alle Eigenschaften und Methoden zur Verfügung, die für vordefinierte Dialoge gelten. Insbesondere die Reihe der Methoden CreateXXX() zum Hinzufügen neuer Dialogsteuerelemente.

## Abrufen der Instanz "Dialog", die ein Dialogereignis ausgelöst hat

Eine Instanz des Dienstes Dialog kann über den Dienst SFDialogs.DialogEvent abgerufen werden, sofern der Dialog mit dem Dienst Dialog initiiert wurde. Im Beispiel unten enthält oDlg die Instanz Dialog, die das Dialogereignis ausgelöst hat.

        Sub aDialogEventHander(ByRef poEvent As Object)
            Dim oDlg As Object
            Set oDlg = CreateScriptService("SFDialogs.DialogEvent", poEvent)
            ' ...
        End Sub

Oder mit Python:

        def control_event_handler(event: uno):
            dlg = CreateScriptService("SFDialogs.DialogEvent", event)
            # ...

Beachten Sie, dass in den vorherigen Beispielen das Präfix "SFDialogs." weggelassen werden kann, wenn es angebracht erscheint.

### Behandlung von Ausnahmen in Ereignishandlern

Beim Erstellen einer Ereignisbehandlungsroutine für Dialogereignisse empfiehlt es sich, Fehler innerhalb der Subroutine selbst zu behandeln. Angenommen, der unten stehende Ereignishandler wird aufgerufen, wenn die Maustaste im Dialogfenster gedrückt wird.

        Sub OnMouseButtonPressed(ByRef oEvent As Object)
        On Local Error GoTo Catch
            Dim oDialog As Object
            oDialog = CreateScriptService("DialogEvent", oEvent)
            ' Das Ereignis verarbeiten
            Exit Sub
        Catch:
            MsgBox SF_Exception.Description
            SF_Exception.Clear
        End Sub

Rufen Sie SF_Exception.Clear auf, wenn Sie nicht möchten, dass der Fehler nach Beendigung der Dialogausführung weitergegeben wird.

Verwenden Sie in Python native Blöcke try/except für die Ausnahmebehandlung, wie unten gezeigt:

        def on_mouse_button_pressed(event=None):
            try:
                dlg = CreateScriptService("DialogEvent", event)
                # Verarbeite das Ereignis
            except Exception as e:
                # Das Objekt "bas" ist eine Instanz des Dienstes Basic
                bas.MsgBox(str(e))

## Eigenschaften

Name | Schreibgeschützt | Typ | Beschreibung
--- | --- | --- | ---
OKBUTTON | Ja | Integer | Wert = 1. Die Schaltfläche "OK" wurde gedrückt.
CANCELBUTTON | Ja | Integer | Wert = 0. Die Schaltfläche "Abbrechen" wurde gedrückt.
Caption | Nein | String | Legt den Titel des Dialogs fest.
Height | Nein | Long | Legt die Höhe des Dialogs fest.
Modal | Ja | Boolean | Legt fest, ob der Dialog derzeit im modalen Modus ausgeführt wird.
Name | Ja | String | Der Name des Dialogs
Page | Nein | Integer | Der Dialog kann mehrere Seiten haben, die vom Benutzer Schritt für Schritt durchlaufen werden können. Die Eigenschaft "Page" des Objekts "Dialog" definiert, welche Seite des Dialogs aktiv ist.
Visible | Nein | Boolean | Legt fest, ob der Dialog auf dem Desktop sichtbar ist. Standardmäßig ist er nicht sichtbar, bis die Methode "Execute()" ausgeführt wird und danach sichtbar ist.
XDialogModel | Ja | UNO Objekt | Das UNO-Objekt, welches das Dialogmodell darstellt. Siehe XControlModel und UnoControlDialogModel in der Programmierschnittstelle (API).
XDialogView | Ja | UNO Objekt | Das UNO-Objekt, das die Dialogansicht darstellt. Siehe XControl und UnoControlDialog in der Dokumentation der Programmierschnittstelle (API) für detaillierte Informationen.
Width | Nein | Long | Legt die Breite des Dialogs fest.

## Ereigniseigenschaften

Eigenschaften On… geben eine URI-Zeichenfolge mit der Bezug zu dem durch das Ereignis ausgelöste Skript zurück. Eigenschaften On… können programmgesteuert festgelegt werden.
Lesen Sie die Spezifikation unter scripting framework URI specification.

Name | Lesen/Schreiben | Basic-IDE-Beschreibung
--- | --- | ---
OnFocusGained | Ja | Beim Erhalten des Fokus
OnFocusLost | Ja | Beim Verlust des Fokus
OnKeyPressed | Ja | Beim Tastendruck
OnKeyReleased | Ja | Beim Taste loslassen
OnMouseDragged | Ja | Bei Mausbewegung während Tastedruck
OnMouseEntered | Ja | Maus hinein
OnMouseExited | Ja | Maus heraus
OnMouseMoved | Ja | Mausbewegung
OnMousePressed | Ja | Mausklick
OnMouseReleased | Ja | Maustaste lösen

Das Zuweisen von Ereignissen über die Basic-IDE und das Zuweisen von Ereignissen über Makros schließen sich gegenseitig aus.

Liste der Methoden im Dienst "Dialog"
Activate Center Controls CloneControl CreateButton CreateCheckBox CreateComboBox CreateCurrencyField CreateDateField CreateFileControl CreateFixedLine | CreateFixedText CreateFormattedField CreateGroupBox CreateHyperlink CreateImageControl CreateListBox CreateNumericField CreatePatternField CreateProgressBar CreateRadioButton CreateScrollBar | CreateTableControl CreateTextField CreateTimeField CreateTreeControl EndExecute Execute GetTextsFromL10N Resize OrderTabs SetPageManager Terminate

Die Bemaßung eines Dialogs erfolgt mittels Einheiten Map AppFont. Ein Dialog- oder Steuerungsmodell verwendet auch Einheiten AppFont, während ihre Ansichten Pixel verwenden.

## Activate

Setzt den Fokus auf die aktuelle Instanz von Dialog. Gib True zurück, wenn die Fokussierung erfolgreich war.

Diese Methode wird von einem Dialog- oder Steuerereignis aufgerufen oder wenn ein Dialog im nicht-modalen Modus angezeigt wird.

### Syntax:

svc.Activate(): bool

### Beispiel:

          Dim oDlg As Object
          Set oDlg = CreateScriptService(,, "myDialog")
          oDlg.Execute()
          ' ...
          oDlg.Activate()

Python- und LibreOffice Basic-Beispiele setzen beide voraus, dass der Dialog in der Bibliothek Standard des aktuellen Dokuments gespeichert ist.

         dlg = CreateScriptService(,,'myDialog')
         dlg.Execute()
         # ...
         dlg.Activate()

## Center

Zentriert den aktuellen Dialog in der Mitte eines übergeordneten Fensters. Ohne Argumente zentriert die Methode den Dialog in der Mitte des aktuellen Fensters.

Gibt bei Erfolg True zurück.

### Syntax:

svc.Center(opt Parent: obj): bool

### Parameter:

Parent: Ein optionales Objekt …

- ein Dialog "ScriptForge"

- ein Dokument (Calc, Base, …) "ScriptForge"

### Beispiel:

##### In Basic

         Sub TriggerEvent(oEvent As Object)
             Dim oDialog1 As Object, oDialog2 As Object, lExec As Long
             Set oDialog1 = CreateScriptService("DialogEvent", oEvent) ' Der Dialog, der das Ereignis verursacht hat
             Set oDialog2 = CreateScriptService("Dialog", …) ' Öffnet einen zweiten Dialog
             oDialog2.Center(oDialog1)
             lExec = oDialog2.Execute()
             Select Case lExec
                 ...
         End Sub

##### In Python

         def triggerEvent(event: uno):
           dlg1 = CreateScriptService('DialogEvent.Dialog', event) # Der Dialog, der das Ereignis verursacht hat
           dlg2 = CreateScriptService('Dialog', …)  # Öffnet einen zweiten Dialog
           dlg2.Center(dlg1)
           rc = dlg2.Execute()
           if rc is False:
             # ...

## CloneControl

Vervielfältigt ein vorhandenes Steuerelement eines beliebigen Typs im aktuellen Dialog. Das vervielfältigte Steuerelement bleibt unverändert und kann verschoben werden.

### Syntax:

svc.CloneControl(SourceName: str, ControlName: str, Left: num, Top: num): svc

### Parameter:

SourceName: Der Name des zu vervielfältigen Steuerelements.

ControlName: Ein gültiger Steuerelementname als Zeichenfolge, bei der die Groß-/Kleinschreibung beachtet wird. Es darf noch nicht existieren.

Left, Top: Die Koordinaten des neuen Steuerelements, ausgedrückt in Einheiten Map AppFont.

### Rückgabewert:

Eine Instanz des Dienstes SFDialogs.DialogControl oder Nothing.

### Beispiel:

##### In Basic

          Set myButton2 = oDlg.CloneControl("Button1", "Button2", 30, 30)

##### In Python

         dlg = dlg.CloneControl('Button1', 'Button2', 30, 30)

## Controls

Rückgabe:

- die Liste der im Dialog enthaltenen Steuerelemente

- eine Klasseninstanz von DialogControl basierend auf ihrem Namen

### Syntax:

svc.Controls(): str[0..*]

svc.Controls(controlname: str): svc

### Parameter:

ControlName: Ein gültiger Steuerelementname als Zeichenfolge mit Beachtung der Groß-/Kleinschreibung. Wenn nicht vorhanden, wird die Liste der Steuerelementnamen als nullbasierte Matrix zurückgegeben.

### Beispiel:

          Dim myDialog As Object, myList As Variant, myControl As Object
          Set myDialog = CreateScriptService("SFDialogs.Dialog", , "Standard", "Dialog1")
          myList = myDialog.Controls()
          Set myControl = myDialog.Controls("myTextBox")

         dlg = CreateScriptService('SFDialogs.Dialog','', 'Standard', 'Dialog1')
         ctrls = dlg.Controls()
         ctrl = dlg.Controls('myTextBox')

## CreateButton

Erstellt im aktuellen Dialog ein neues Steuerelement vom Typ Button.

### Syntax:

svc.CreateButton(ControlName: str, Place: any, Toggle: bool = False, Push: str = ""): svc

### Parameter:

ControlName: der Name des neuen Steuerelements. Er darf noch nicht existieren.

Place: entweder …

- eine Basic-Matrix oder ein Python-Tupel mit 4 Elementen: (X, Y, Breite, Höhe)

- ein Objekt com.sun.star.awt.Rectangle [X, Y, Breite, Höhe]

Alle Elemente werden in Einheiten Map AppFont ausgedrückt.

Toggle: Wenn True, wird eine Schaltfläche zum Umschalten erstellt. Standard = False

Push: "OK", "CANCEL" oder "" (Standard)

### Rückgabewert:

Eine Instanz des Dienstes SFDialogs.DialogControl oder Nothing.

### Beispiel:

##### In Basic

         Set myButton = oDlg.CreateButton("Button1", Array(20, 20, 60, 15))

##### In Python

         myButton = dlg.CreateButton('Button1', (20, 20, 60, 15))

## CreateCheckBox

Erstellt im aktuellen Dialog ein neues Steuerelement vom Typ CheckBox.

### Syntax:

svc.CreateCheckBox(ControlName: str, Place: any, Multiline: bool = False): svc

### Parameter:

ControlName: der Name des neuen Steuerelements. Er darf noch nicht existieren.

Place: entweder …

- eine Basic-Matrix oder ein Python-Tupel mit 4 Elementen: (X, Y, Breite, Höhe)

- ein Objekt com.sun.star.awt.Rectangle [X, Y, Breite, Höhe]

Alle Elemente werden in Einheiten Map AppFont ausgedrückt.

MultiLine: Wenn True (Standard = False), kann die Beschriftung in mehr als einer Zeile angezeigt werden.

### Rückgabewert:

Eine Instanz des Dienstes SFDialogs.DialogControl oder Nothing.

### Beispiel:

##### In Basic

         Set myCheckBox = oDlg.CreateCheckBox("CheckBox1", Array(20, 20, 60, 15), MultiLine := True)

##### In Python

         myCheckBox = dlg.CreateCheckBox('CheckBox1', (20, 20, 60, 15), MultiLine = True)

## CreateComboBox

Erstellt im aktuellen Dialog ein neues Steuerelement vom Typ ComboBox.

### Syntax:

svc.CreateComboBox(ControlName: str, Place: any, Border: str = "3D", DropDown: bool = True, LineCount: num = 5): svc

### Parameter:

ControlName: der Name des neuen Steuerelements. Er darf noch nicht existieren.

Place: entweder …

- eine Basic-Matrix oder ein Python-Tupel mit 4 Elementen: (X, Y, Breite, Höhe)

- ein Objekt com.sun.star.awt.Rectangle [X, Y, Breite, Höhe]

Alle Elemente werden in Einheiten Map AppFont ausgedrückt.

Border: "3D" (Standard), "FLAT" oder "NONE"

DropDown: Wenn True (Standard), wird eine Dropdown-Schaltfläche angezeigt

LineCount: Gibt die maximale Zeilenanzahl an, die im Dropdown-Menü angezeigt wird (Standard = 5)

### Rückgabewert:

Eine Instanz des Dienstes SFDialogs.DialogControl oder Nothing.

### Beispiel:

##### In Basic

         Set myComboBox = oDlg.CreateComboBox("ComboBox1", Array(20, 20, 60, 15), Dropdown := True)

##### In Python

         myComboBox = dlg.CreateComboBox('ComboBox1', (20, 20, 60, 15), Dropdown = True)

## CreateCurrencyField

Erstellt im aktuellen Dialog ein neues Steuerelement vom Typ CurrencyField.

### Syntax:

svc.CreateCurrencyField(ControlName: str, Place: any, Border ="3D", SpinButton: bool = False, MinValue: num = -1000000, MaxValue: num = +1000000, Increment: num = 1, Accuracy: num = 2): svc

### Parameter:

ControlName: der Name des neuen Steuerelements. Er darf noch nicht existieren.

Place: entweder …

- eine Basic-Matrix oder ein Python-Tupel mit 4 Elementen: (X, Y, Breite, Höhe)

- ein Objekt com.sun.star.awt.Rectangle [X, Y, Breite, Höhe]

Alle Elemente werden in Einheiten Map AppFont ausgedrückt.

Border: "3D" (Standard), "FLAT" oder "NONE"

SpinButton: Wenn True (Standard = False), ist eine Drehfeld-Schaltfläche vorhanden

MinValue: der kleinste Wert, der in das Steuerelement eingegeben werden kann. Standard = -1000000

MaxValue: der größte Wert, der in das Steuerelement eingegeben werden kann. Standard = +1000000

Increment: die Schrittweite, wenn die Drehfeld-Schaltfläche gedrückt wird. Standard = 1

Accuracy: Gibt die Dezimalgenauigkeit an. Standard = 2 Dezimalstellen

### Rückgabewert:

Eine Instanz des Dienstes SFDialogs.DialogControl oder Nothing.

### Beispiel:

##### In Basic

         Set myCurrencyField = oDlg.CreateCurrencyField("CurrencyField1", Array(20, 20, 60, 15), SpinButton := True)

##### In Python

         myCurrencyField = dlg.CreateCurrencyField('CurrencyField1', (20, 20, 60, 15), SpinButton = True)

## CreateDateField

Erstellt im aktuellen Dialog ein neues Steuerelement vom Typ DateField.

### Syntax:

svc.CreateDateField(ControlName: str, Place: any, Border: str = "3D", DropDown: bool = False, opt MinDate: datetime, opt MaxDate: datetime): svc

### Parameter:

ControlName: der Name des neuen Steuerelements. Er darf noch nicht existieren.

Place: entweder …

- eine Basic-Matrix oder ein Python-Tupel mit 4 Elementen: (X, Y, Breite, Höhe)

- ein Objekt com.sun.star.awt.Rectangle [X, Y, Breite, Höhe]

Alle Elemente werden in Einheiten Map AppFont ausgedrückt.

Border: "3D" (Standard), "FLAT" oder "NONE"

DropDown: Wenn True (Standard = False), wird eine Dropdown-Schaltfläche angezeigt

MinDate: das kleinste Datum, das in das Steuerelement eingegeben werden kann. Standard = 01.01.1900

MaxDate: das größte Datum, das in das Steuerelement eingegeben werden kann. Standard = 31.12.2200

### Rückgabewert:

Eine Instanz des Dienstes SFDialogs.DialogControl oder Nothing.

### Beispiel:

##### In Basic

         Set myDateField = oDlg.CreateDateField("DateField1", Array(20, 20, 60, 15), Dropdown := True)

##### In Python

         myDateField = dlg.CreateDateField('DateField1', (20, 20, 60, 15), Dropdown = True)

## CreateFileControl

Erstellt im aktuellen Dialog ein neues Steuerelement vom Typ FileControl.

### Syntax:

svc.CreateFileControl(ControlName: str, Place: any, Border: str = "3D"): svc

### Parameter:

ControlName: der Name des neuen Steuerelements. Er darf noch nicht existieren.

Place: entweder …

- eine Basic-Matrix oder ein Python-Tupel mit 4 Elementen: (X, Y, Breite, Höhe)

- ein Objekt com.sun.star.awt.Rectangle [X, Y, Breite, Höhe]

Alle Elemente werden in Einheiten Map AppFont ausgedrückt.

Border: "3D" (Standard), "FLAT" oder "NONE"

### Rückgabewert:

Eine Instanz des Dienstes SFDialogs.DialogControl oder Nothing.

### Beispiel:

##### In Basic

         Set myFileControl = oDlg.CreateFileControl("FileControl1", Array(20, 20, 60, 15))

##### In Python

         myFileControl = dlg.CreateFileControl('FileControl1', (20, 20, 60, 15))

## CreateFixedLine

Erstellt im aktuellen Dialog ein neues Steuerelement vom Typ FixedLine.

### Syntax:

svc.CreateFixedLine(ControlName: str, Place: any, Orientation: str): svc

### Parameter:

ControlName: der Name des neuen Steuerelements. Er darf noch nicht existieren.

Place: entweder …

- eine Basic-Matrix oder ein Python-Tupel mit 4 Elementen: (X, Y, Breite, Höhe)

- ein Objekt com.sun.star.awt.Rectangle [X, Y, Breite, Höhe]

Alle Elemente werden in Einheiten Map AppFont ausgedrückt.

Orientation: Für die horizontale Ausrichtung verwenden Sie „H“ oder „Horizontal“; Für die vertikale Ausrichtung verwenden Sie „V“ oder „Vertical“.

### Rückgabewert:

Eine Instanz des Dienstes SFDialogs.DialogControl oder Nothing.

### Beispiel:

##### In Basic

         Set myFixedLine = oDlg.CreateFixedLine("FixedLine1", Array(20, 20, 60, 15), Orientation := "vertical")

##### In Python

         myFixedLine = dlg.CreateFixedLine('FixedLine1', (20, 20, 60, 15), Orientation = 'vertical')

## CreateFixedText

Erstellt im aktuellen Dialog ein neues Steuerelement vom Typ FixedText.

### Syntax:

svc.CreateFixedText(ControlName: str, Place: any, Border: str = "3D", MultiLine: bool = False, Align: str = "LEFT", VerticalAlign: str = "TOP"): svc

### Parameter:

ControlName: der Name des neuen Steuerelements. Er darf noch nicht existieren.

Place: entweder …

- eine Basic-Matrix oder ein Python-Tupel mit 4 Elementen: (X, Y, Breite, Höhe)

- ein Objekt com.sun.star.awt.Rectangle [X, Y, Breite, Höhe]

Alle Elemente werden in Einheiten Map AppFont ausgedrückt.

Border: "NONE" (Standard), "FLAT" oder "3D"

Multiline: Wenn True (Standard = False), kann die Beschriftung in mehr als einer Zeile angezeigt werden

Align: horizontale Ausrichtung, "LEFT" (Standard), "CENTER" oder "RIGHT"

VerticalAlign: vertikale Ausrichtung, "TOP" (Standard), "MIDDLE" oder "BOTTOM"

### Rückgabewert:

Eine Instanz des Dienstes SFDialogs.DialogControl oder Nothing.

### Beispiel:

##### In Basic

         Set myFixedText = oDlg.CreateFixedText("FixedText1", Array(20, 20, 60, 15), MultiLine := True)

##### In Python

         myFixedText = dlg.CreateFixedText('FixedText1', (20, 20, 60, 15), MultiLine = True)

## CreateFormattedField

Erstellt im aktuellen Dialog ein neues Steuerelement vom Typ FormattedField.

### Syntax:

svc.CreateFormattedField(ControlName: str, Place: any, Border: str = "3D", SpinButton: bool = False, MinValue: num = -1000000, MaxValue: num = +1000000): svc

### Parameter:

ControlName: der Name des neuen Steuerelements. Er darf noch nicht existieren.

Place: entweder …

- eine Basic-Matrix oder ein Python-Tupel mit 4 Elementen: (X, Y, Breite, Höhe)

- ein Objekt com.sun.star.awt.Rectangle [X, Y, Breite, Höhe]

Alle Elemente werden in Einheiten Map AppFont ausgedrückt.

Border: "3D" (Standard), "FLAT" oder "NONE"

SpinButton: Wenn True (Standard = False), ist eine Drehfeld-Schaltfläche vorhanden

MinValue: der kleinste Wert, der in das Steuerelement eingegeben werden kann. Standard = -1000000

MaxValue: der größte Wert, der in das Steuerelement eingegeben werden kann. Standard = +1000000

### Rückgabewert:

Eine Instanz des Dienstes SFDialogs.DialogControl oder Nothing.

### Beispiel:

##### In Basic

         Set myFormattedField = oDlg.CreateFormattedField("FormattedField1", Array(20, 20, 60, 15), SpinButton := True)

##### In Python

         myFormattedField = dlg.CreateFormattedField('FormattedField1', (20, 20, 60, 15), SpinButton = True)

## CreateGroupBox

Erstellt im aktuellen Dialog ein neues Steuerelement vom Typ GroupBox.

### Syntax:

svc.CreateGroupBox(ControlName: str, Place: any): svc

### Parameter:

ControlName: der Name des neuen Steuerelements. Er darf noch nicht existieren.

Place: entweder …

- eine Basic-Matrix oder ein Python-Tupel mit 4 Elementen: (X, Y, Breite, Höhe)

- ein Objekt com.sun.star.awt.Rectangle [X, Y, Breite, Höhe]

Alle Elemente werden in Einheiten Map AppFont ausgedrückt.

### Rückgabewert:

Eine Instanz des Dienstes SFDialogs.DialogControl oder Nothing.

### Beispiel:

##### In Basic

         Set myGroupBox = oDlg.CreateGroupBox("GroupBox1", Array(20, 20, 60, 15))

##### In Python

         myGroupBox = dlg.CreateGroupBox('GroupBox1', (20, 20, 60, 15))

## CreateHyperlink

Erstellt im aktuellen Dialog ein neues Steuerelement vom Typ Hyperlink.

### Syntax:

svc.CreateHyperlink(ControlName: str, Place: any, Border: str = "NONE", MultiLine: bool = False, Align: str = "LEFT", VerticalAlign: str = "TOP"): svc

### Parameter:

ControlName: der Name des neuen Steuerelements. Er darf noch nicht existieren.

Place: entweder …

- eine Basic-Matrix oder ein Python-Tupel mit 4 Elementen: (X, Y, Breite, Höhe)

- ein Objekt com.sun.star.awt.Rectangle [X, Y, Breite, Höhe]

Alle Elemente werden in Einheiten Map AppFont ausgedrückt.

Border: "NONE" (Standard), "FLAT" oder "3D"

MultiLine: Wenn True (Standard = False), kann die Beschriftung in mehr als einer Zeile angezeigt werden

Align: horizontale Ausrichtung, "LEFT" (Standard), "CENTER" oder "RIGHT"

VerticalAlign: vertikale Ausrichtung, "TOP" (Standard), "MIDDLE" oder "BOTTOM"

### Rückgabewert:

Eine Instanz des Dienstes SFDialogs.DialogControl oder Nothing.

### Beispiel:

##### In Basic

         Set myHyperlink = oDlg.CreateHyperlink("Hyperlink1", Array(20, 20, 60, 15), MultiLine := True)

##### In Python

         myHyperlink = dlg.CreateHyperlink('Hyperlink1', (20, 20, 60, 15), MultiLine = True)

## CreateImageControl

Erstellt im aktuellen Dialog ein neues Steuerelement vom Typ ImageControl.

### Syntax:

svc.CreateImageControl(ControlName: str, Place: any, Border: str = "3D", Scale: str = "FITTOSIZE"): svc

### Parameter:

ControlName: der Name des neuen Steuerelements. Er darf noch nicht existieren.

Place: entweder …

- eine Basic-Matrix oder ein Python-Tupel mit 4 Elementen: (X, Y, Breite, Höhe)

- ein Objekt com.sun.star.awt.Rectangle [X, Y, Breite, Höhe]

Alle Elemente werden in Einheiten Map AppFont ausgedrückt.

Border: "3D" (Standard), "FLAT" oder "NONE"

Scale: Einer der folgenden Werte: "FITTOSIZE" (Standard), "KEEPRATIO" oder "NO"

### Rückgabewert:

Eine Instanz des Dienstes SFDialogs.DialogControl oder Nothing.

### Beispiel:

##### In Basic

         Set myImageControl = oDlg.CreateImageControl("ImageControl1", Array(20, 20, 60, 15))

##### In Python

           myImageControl = dlg.CreateImageControl('ImageControl1", (20, 20, 60, 15))

## CreateListBox

Erstellt im aktuellen Dialog ein neues Steuerelement vom Typ ListBox.

### Syntax:

svc.CreateListBox(ControlName: str, Place: any, Border: str = "3D", DropDown: bool = True, LineCount: num = 5, MultiSelect: bool = False): svc

### Parameter:

ControlName: der Name des neuen Steuerelements. Er darf noch nicht existieren.

Place: entweder …

- eine Basic-Matrix oder ein Python-Tupel mit 4 Elementen: (X, Y, Breite, Höhe)

- ein Objekt com.sun.star.awt.Rectangle [X, Y, Breite, Höhe]

Alle Elemente werden in Einheiten Map AppFont ausgedrückt.

Border: "3D" (Standard), "FLAT" oder "NONE"

DropDown: Wenn True (Standard), wird eine Dropdown-Schaltfläche angezeigt

LineCount: Gibt die maximale Zeilenanzahl an, die im Dropdown-Menü angezeigt wird (Standard = 5)

MultiSelect: Wenn True, kann mehr als ein Eintrag ausgewählt werden. Standard = False

### Rückgabewert:

Eine Instanz des Dienstes SFDialogs.DialogControl oder Nothing.

### Beispiel:

##### In Basic

         Set myListBox = oDlg.CreateListBox("ListBox1", Array(20, 20, 60, 15), Dropdown := True, MultiSelect := True)

##### In Python

         myListBox = dlg.CreateListBox('ListBox1', (20, 20, 60, 15), Dropdown = True, MultiSelect = True)

## CreateNumericField

Erstellt im aktuellen Dialog ein neues Steuerelement vom Typ NumericField.

### Syntax:

svc.CreateNumericField(ControlName: str, Place: any, Border: str = "3D", SpinButton: bool = False, MinValue: num = -1000000, MaxValue: num = 1000000, Increment: num = 1, Accuracy: num = 2): svc

### Parameter:

ControlName: der Name des neuen Steuerelements. Er darf noch nicht existieren.

Place: entweder …

- eine Basic-Matrix oder ein Python-Tupel mit 4 Elementen: (X, Y, Breite, Höhe)

- ein Objekt com.sun.star.awt.Rectangle [X, Y, Breite, Höhe]

Alle Elemente werden in Einheiten Map AppFont ausgedrückt.

Border: "3D" (Standard), "FLAT" oder "NONE"

SpinButton: Wenn True (Standard = False), ist eine Drehfeld-Schaltfläche vorhanden

MinValue: der kleinste Wert, der in das Steuerelement eingegeben werden kann. Standard = -1000000

MaxValue: der größte Wert, der in das Steuerelement eingegeben werden kann. Standard = +1000000

Increment: die Schrittweite, wenn die Drehfeld-Schaltfläche gedrückt wird. Standard = 1

Accuracy: Gibt die Dezimalgenauigkeit an. Standard = 2 Dezimalstellen

### Rückgabewert:

Eine Instanz des Dienstes SFDialogs.DialogControl oder Nothing.

### Beispiel:

##### In Basic

         Set myNumericField = oDlg.CreateNumericField("NumericField1", Array(20, 20, 60, 15), SpinButton := True)

##### In Python

         myNumericField = dlg.CreateNumericField('NumericField1', (20, 20, 60, 15), SpinButton = True)

## CreatePatternField

Erstellt im aktuellen Dialog ein neues Steuerelement vom Typ PatternField.

### Syntax:

svc.CreatePatternField(ControlName: str, Place: any, Border: str = "3D", EditMask: str, opt LiteralMax: str): svc

### Parameter:

ControlName: der Name des neuen Steuerelements. Er darf noch nicht existieren.

Place: entweder …

- eine Basic-Matrix oder ein Python-Tupel mit 4 Elementen: (X, Y, Breite, Höhe)

- ein Objekt com.sun.star.awt.Rectangle [X, Y, Breite, Höhe]

Alle Elemente werden in Einheiten Map AppFont ausgedrückt.

Border: "3D" (Standard), "FLAT" oder "NONE"

EditMask: ein Zeichencode, der bestimmt, was der Benutzer eingeben darf
Siehe Pattern_Field im Wiki für weitere Informationen.

LiteralMask: enthält die Anfangswerte, die im Musterfeld angezeigt werden

### Rückgabewert:

Eine Instanz des Dienstes SFDialogs.DialogControl oder Nothing.

### Beispiel:

##### In Basic

         Set myPatternField = oDlg.CreatePatternField("PatternField1", Array(20, 20, 60, 15), EditMask := "NNLNNLLLLL", LiteralMask := "__.__.2002")

##### In Python

         myPatternField = dlg.CreatePatternField('PatternField1', (20, 20, 60, 15), EditMask = 'NNLNNLLLLL', LiteralMask = '__.__.2002')

## CreateProgressBar

Erstellt im aktuellen Dialog ein neues Steuerelement vom Typ ProgressBar.

### Syntax:

svc.CreateProgressBar(ControlName: str, opt Place: any, Border: str = "3D", MinValue: num = 0, MaxValue: num = 100): svc

### Parameter:

ControlName: der Name des neuen Steuerelements. Er darf noch nicht existieren.

Place: entweder …

- eine Basic-Matrix oder ein Python-Tupel mit 4 Elementen: (X, Y, Breite, Höhe)

- ein Objekt com.sun.star.awt.Rectangle [X, Y, Breite, Höhe]

Alle Elemente werden in Einheiten Map AppFont ausgedrückt.

Border: "3D" (Standard), "FLAT" oder "NONE"

MinValue: der kleinste Wert, der in das Steuerelement eingegeben werden kann. Standard = 0

MaxValue: der größte Wert, der in das Steuerelement eingegeben werden kann. Standard = 100

### Rückgabewert:

Eine Instanz des Dienstes SFDialogs.DialogControl oder Nothing.

### Beispiel:

##### In Basic

         Set myProgressBar = oDlg.CreateProgressBar("ProgressBar1", Array(20, 20, 60, 15), MaxValue := 1000)

##### In Python

         myProgressBar = dlg.CreateProgressBar('ProgressBar1', (20, 20, 60, 15), MaxValue = 1000)

## CreateRadioButton

Erstellt im aktuellen Dialog ein neues Steuerelement vom Typ RadioButton.

### Syntax:

svc.CreateRadioButton(ControlName: str, Place: any, MultiLine: bool = False): svc

### Parameter:

ControlName: der Name des neuen Steuerelements. Er darf noch nicht existieren.

Place: entweder …

- eine Basic-Matrix oder ein Python-Tupel mit 4 Elementen: (X, Y, Breite, Höhe)

- ein Objekt com.sun.star.awt.Rectangle [X, Y, Breite, Höhe]

Alle Elemente werden in Einheiten Map AppFont ausgedrückt.

MultiLine: Wenn True (Standard = False), kann die Beschriftung in mehr als einer Zeile angezeigt werden

### Rückgabewert:

Eine Instanz des Dienstes SFDialogs.DialogControl oder Nothing.

### Beispiel:

##### In Basic

         Set myRadioButton = oDlg.CreateRadioButton("RadioButton1", Array(20, 20, 60, 15), MultiLine := True)

##### In Python

         myRadioButton = dlg.CreateRadioButton('RadioButton1', (20, 20, 60, 15), MultiLine = True)

## CreateScrollBar

Erstellt im aktuellen Dialog ein neues Steuerelement vom Typ ScrollBar.

### Syntax:

svc.CreateScrollBar(ControlName: str, Place, Orientation: str, Border: str = "3D", MinValue: num = 0, MaxValue: num = 100): svc

### Parameter:

ControlName: der Name des neuen Steuerelements. Er darf noch nicht existieren.

Place: entweder …

- eine Basic-Matrix oder ein Python-Tupel mit 4 Elementen: (X, Y, Breite, Höhe)

- ein Objekt com.sun.star.awt.Rectangle [X, Y, Breite, Höhe]

Alle Elemente werden in Einheiten Map AppFont ausgedrückt.

Orientation: Für die horizontale Ausrichtung verwenden Sie „H“ oder „Horizontal“; Für die vertikale Ausrichtung verwenden Sie „V“ oder „Vertical“.

Border: "3D" (Standard), "FLAT" oder "NONE"

MinValue: der kleinste Wert, der in das Steuerelement eingegeben werden kann. Standard = 0

MaxValue: der größte Wert, der in das Steuerelement eingegeben werden kann. Standard = 100

### Rückgabewert:

Eine Instanz des Dienstes SFDialogs.DialogControl oder Nothing.

### Beispiel:

##### In Basic

         Set myScrollBar = oDlg.CreateScrollBar("ScrollBar1", Array(20, 20, 60, 15), MaxValue := 1000)

##### In Python

         myScrollBar = dialog.CreateScrollBar('ScrollBar1', (20, 20, 60, 15), MaxValue = 1000)

## CreateTableControl

Erstellt im aktuellen Dialog ein neues Steuerelement vom Typ TableControl.

### Syntax:

svc.CreateTableControl(ControlName: str, Place: any, Border: str = "3D", RowHeaders: bool = True, ColumnHeaders: bool = True, ScrollBars: str = "N", GridLines: bool = False): svc

### Parameter:

ControlName: der Name des neuen Steuerelements. Er darf noch nicht existieren.

Place: entweder …

- eine Basic-Matrix oder ein Python-Tupel mit 4 Elementen: (X, Y, Breite, Höhe)

- ein Objekt com.sun.star.awt.Rectangle [X, Y, Breite, Höhe]

Alle Elemente werden in Einheiten Map AppFont ausgedrückt.

Border: "3D" (Standard), "FLAT" oder "NONE"

RowHeaders: Wenn True (Standard), werden die Zeilenköpfe angezeigt

ColumnHeaders: Wenn True (Standard), werden die Spaltenköpfe angezeigt

ScrollBars: mögliche Werte sind: "H" oder "Horizontal" (horizontale Bildlaufleisten), "V" oder "Vertical" (vertikale Bildlaufleisten), "B" oder "Both" (beide Bildlaufleisten); "N" oder "None" (Standard) für keine Bildlaufleisten. Bildlaufleisten werden dynamisch angezeigt, wenn sie benötigt werden.

GridLines: Wenn True (Standard = False), werden horizontale und vertikale Linien zwischen den Gitterzellen gezeichnet

### Rückgabewert:

Eine Instanz des Dienstes SFDialogs.DialogControl oder Nothing.

### Beispiel:

##### In Basic

         Set myTableControl = oDlg.CreateTableControl("TableControl1", Array(20, 20, 60, 15), ScrollBars := "B")

##### In Python

         myTableControl = dlg.CreateTableControl('TableControl1', (20, 20, 60, 15), ScrollBars = 'B')

## CreateTextField

Erstellt im aktuellen Dialog ein neues Steuerelement vom Typ TextField.

### Syntax:

svc.CreateTextField(ControlName: str, Place: any, Border: str = "3D", MultiLine: bool = False, MaximumLength: num = 0, PasswordCharacter: str = ""): svc

### Parameter:

ControlName: der Name des neuen Steuerelements. Er darf noch nicht existieren.

Place: entweder …

- eine Basic-Matrix oder ein Python-Tupel mit 4 Elementen: (X, Y, Breite, Höhe)

- ein Objekt com.sun.star.awt.Rectangle [X, Y, Breite, Höhe]

Alle Elemente werden in Einheiten Map AppFont ausgedrückt.

Border: "3D" (Standard), "FLAT" oder "NONE"

MultiLine: Wenn True (Standard = False), kann die Beschriftung in mehr als einer Zeile angezeigt werden

MaximumLength: die maximale Zeichenanzahl (Standard = 0 bedeutet unbegrenzt)

PasswordCharacter: ein einzelnes Zeichen, welches den Rückgabewert für ein Passwort-Textfeld angibt (Standard = "")

### Rückgabewert:

Eine Instanz des Dienstes SFDialogs.DialogControl oder Nothing.

### Beispiel:

##### In Basic

    Set myTextField = oDlg.CreateTextField("TextField1", Array(20, 20, 120, 50), MultiLine := True)

##### In Python

         myTextField = dlg.CreateTextField('TextField1', (20, 20, 120, 50), MultiLine = True)

## CreateTimeField

Erstellt im aktuellen Dialog ein neues Steuerelement vom Typ TimeField.

### Syntax:

svc.CreateTimeField(ControlName: str, Place: any, Border: str = "3D", MinTime: num = 0, MaxTime: num = 24): svc

### Parameter:

ControlName: der Name des neuen Steuerelements. Er darf noch nicht existieren.

Place: entweder …

- eine Basic-Matrix oder ein Python-Tupel mit 4 Elementen: (X, Y, Breite, Höhe)

- ein Objekt com.sun.star.awt.Rectangle [X, Y, Breite, Höhe]

Alle Elemente werden in Einheiten Map AppFont ausgedrückt.

Border: "3D" (Standard), "FLAT" oder "NONE"

MinTime: die kleinste Zeit, die in das Steuerelement eingegeben werden kann. Standard = 0

MaxTime: die größte Zeit, die in das Steuerelement eingegeben werden kann. Standard = 24 Stunden

### Rückgabewert:

Eine Instanz des Dienstes SFDialogs.DialogControl oder Nothing.

### Beispiel:

##### In Basic

         Set myTimeField = oDlg.CreateTimeField("TimeField1", Array(20, 20, 60, 15))

##### In Python

         myTimeField = dlog.CreateTimeField('TimeField1', (20, 20, 60, 15))

## CreateTreeControl

Erstellt im aktuellen Dialog ein neues Steuerelement vom Typ TreeControl.

### Syntax:

svc.CreateTreeControl(ControlName: str, Place: any, Border = "3D"): svc

### Parameter:

ControlName: der Name des neuen Steuerelements. Er darf noch nicht existieren.

Place: entweder …

- eine Basic-Matrix oder ein Python-Tupel mit 4 Elementen: (X, Y, Breite, Höhe)

- ein Objekt com.sun.star.awt.Rectangle [X, Y, Breite, Höhe]

Alle Elemente werden in Einheiten Map AppFont ausgedrückt.

Border: "3D" (Standard), "FLAT" oder "NONE"

### Rückgabewert:

Eine Instanz des Dienstes SFDialogs.DialogControl oder Nothing.

### Beispiel:

##### In Basic

         Set myTreeControl = oDlg.CreateTreeControl("TreeControl1", Array(20, 20, 60, 15))

##### In Python

         myTreeControl = dlg.CreateTreeControl('TreeControl1', (20, 20, 60, 15))

## EndExecute

Beendet die Anzeige eines modalen Dialogs und gibt das Argument als Rückgabewert für die aktuell laufende Aktion Execute() zurück.

EndExecute() ist normalerweise in der Verarbeitung eines Makros enthalten, das durch ein Dialog- oder Steuerereignis ausgelöst wird.

### Syntax:

svc.EndExecute(returnvalue: int)

### Parameter:

returnvalue: Der Wert, der an die laufende Methode Execute() übergeben wird.

### Beispiel:

##### In Basic

          Sub OnEvent(poEvent As com.sun.star.lang.EventObject)
              Dim oDlg As Object
              Set oDlg = CreateScriptService("SFDialogs.DialogEvent", poEvent)
              oDlg.EndExecute(ReturnValue := 25)
          End Sub

##### In Python

         from com.sun.star.lang import EventObject
         def on_event(event: EventObject):
             dlg = CreateScriptService("SFDialogs.DialogEvent", event)
             dlg.EndExecute(25)

Obige Erwähnungen von com.sun.star.lang.EventObject sind optional. Solche Anmerkungen helfen bei der Identifizierung der LibreOffice-Programmierschnittstelle (API).

## Execute

Zeigt den Dialog an und wartet, wenn es modal ist, auf seine Beendigung durch den Benutzer. Der zurückgegebene Wert ist:

- 0: Schaltfläche Abbrechen gedrückt

- 1: Schaltfläche OK gedrückt

- Andernfalls wurde der Dialog mit einer Anweisung EndExecute() beendet, die von einem Dialog- oder Steuerereignis ausgegeben wurde

Bei nicht-modalen Dialogen gibt die Methode immer 0 zurück und die Ausführung des Makros wird fortgesetzt.

### Syntax:

svc.Execute(modal: bool = True): int

### Parameter:

modal: False bei nicht-modalem Dialog. Standard = True.

### Beispiel:

In diesem einfachen Beispiel wird der Dialog myDialog in der Bibliothek Standard des aktuellen Dokuments gespeichert.

          Dim oDlg As Object, lReturn As Long
          Set oDlg = CreateScriptService("SFDialogs.Dialog", , , "myDialog")
          lReturn = oDlg.Execute(Modal := False)
          Select Case lReturn
              ' ...
          End Select

Dieser Python-Code zeigt den modalen Dialog DlgConvert aus der gemeinsamen Basisbibliothek Euro an.

         dlg = CreateScriptService("SFDialogs.Dialog", 'GlobalScope', 'Euro', "DlgConvert")
         rc = dlg.Execute()
         if rc == dlg.CANCELBUTTON:
             # ...

## GetTextsFromL10N

Ersetzt alle festen Textzeichenfolgen in einem Dialog durch ihre übersetzten Versionen basierend auf einer Dienstinstanz L10N. Diese Methode übersetzt die folgenden Zeichenfolgen:

- Der Titel des Dialogs.

- Die Beschriftung der folgenden Steuerelementtypen: Schaltfläche, Markierfeld, Geschützte Linie, Beschriftungsfeld, Gruppenfeld und Optionsfeld.

- Statische Zeichenfolgen in Listenfeldern und Kombinationsfeldern.

- Der Hilfetext, der angezeigt wird, wenn die Maus über das Steuerelement bewegt wird.

Die Methode gibt bei Erfolg True zurück.

Verwenden Sie zum Erstellen einer Liste übersetzbarer Zeichenfolgen in einem Dialog die Methode AddTextsFromDialog des Dienstes "L10N".

### Syntax:

svc.GetTextsFromL10N(l10n: svc): bool

### Parameter:

l10n: Eine Dienstinstanz L10N, von der übersetzte Zeichenfolgen abgerufen werden.

### Beispiel:

Das folgende Beispiel lädt übersetzte Zeichenfolgen und wendet sie auf den Dialog "MyDialog" an.

##### In Basic

         oDlg = CreateScriptService("Dialog", "GlobalScope", "Standard", "MyDialog")
         myPO = CreateScriptService("L10N", "/home/user/po_files/")
         oDlg.GetTextsFromL10N(myPO)
         oDlg.Execute()

##### In Python

         dlg = CreateScriptService("Dialog", "GlobalScope", "Standard", "MyDialog")
         myPO = CreateScriptService("L10N", "/home/user/po_files/")
         dlg.GetTextsFromL10N(myPO)
         dlg.Execute()

Lesen Sie die Hilfeseite zum Dienst L10N, um mehr darüber zu erfahren, wie PO- und POT-Dateien gehandhabt werden.

## OrderTabs

Legt die Tabulatorreihenfolge einer Reihe von Steuerelementen fest. Die Reihenfolge der Steuerelemente wird als Matrix von Steuerelementnamen vom ersten bis zum letzten angegeben.

Auf Steuerelemente mit einem Index >= 1 kann nicht mit [Tabulator] zugegriffen werden, wenn:
- sie in der angegebenen Liste weggelassen werden
- ihr Typ "FixedLine", "GroupBox" oder "ProgressBar" ist
- sie deaktiviert sind

### Syntax:

svc.TabsList(TabsList: num, Start: num = 1, Increment: num = 1): bool

### Parameter:

TabsList: eine Matrix gültiger Steuerelementnamen in der Tabulatorreihenfolge

Start: der Tabulatorindex, der dem ersten Steuerelement in der Liste zugewiesen werden soll. Standard = 1

Increment: die Differenz zwischen zwei aufeinanderfolgenden Tabulatorindizes. Standard = 1

### Rückgabewert:

Gibt bei Erfolg True zurück.

### Beispiel:

##### In Basic

         oDlg.OrderTabs(Array("myListBox", "myTextField", "myNumericField"), Start := 10)

##### In Python

         dlg.OrderTabs(('myListBox', 'myTextField', 'myNumericField'), Start = 10)

## Resize

Verschiebt die obere linke Ecke eines Dialogs auf neue Koordinaten und/oder ändert seine Abmessungen. Alle Entfernungen werden in Einheit AppFont ausgedrückt. Ohne Argumente setzt die Methode die ursprünglichen Abmessungen zurück. Gibt True zurück, wenn die Größenänderung erfolgreich war.

### Syntax:

svc.Resize(opt Left: num, opt Top: num, opt Width: num, opt Height: num): bool

### Parameter:

Left: der horizontale Abstand von der oberen linken Ecke

Top: Der vertikale Abstand von der oberen linken Ecke

Width: die Breite des Rechtecks, das den Dialog enthält

Height: die Höhe des Rechtecks, das den Dialog enthält

Fehlende Argumente bleiben unverändert

### Beispiel:

##### In Basic

         oDlg.Resize(1000, 2000, Height := 6000) ' Die Breite wird nicht geändert

##### In Python

         dlg.Resize(1000, 2000, Height = 6000)  # Die Breite wird nicht geändert

## SetPageManager

Definiert, welche Steuerelemente in einem Dialog für das Wechseln von Seiten verantwortlich sind, wodurch die Verwaltung der Eigenschaft Page eines Dialogs und seiner Steuerelemente vereinfacht wird.

Dialoge können mehrere Seiten haben und die aktuell sichtbare Seite wird durch die Dialogeigenschaft Page definiert. Wenn die Eigenschaft Page unverändert gelassen wird, ist die standardmäßig sichtbare Seite gleich 0 (Null), was bedeutet, dass keine bestimmte Seite definiert ist und alle sichtbaren Steuerelemente angezeigt werden, unabhängig von dem Wert, der in ihrer eigenen Eigenschaft Page gesetzt ist.

Wenn die Eigenschaft Page eines Dialogs auf einen anderen Wert als 1, 2, 3 und so weiter geändert wird, dann werden nur die Steuerelemente angezeigt, deren Eigenschaft Page mit der aktuellen Dialogseite übereinstimmen.

Durch die Verwendung der Methode SetPageManager ist es möglich, vier Arten von Seitenmanagern zu definieren:

- Listenfeld oder Kombinationsfeld: Es entspricht jeder Eintrag in dem Listen- oder Kombinationsfeld einer Seite. Das erste Element bezieht sich auf Seite 1, das zweite Element bezieht sich auf Seite 2 und so weiter.

- Gruppe von Optionsfeldern: definiert eine Gruppe von Optionsfeldern, die steuern, welche Seite sichtbar ist.

- Schaltflächenfolge: definiert eine Reihe von Schaltflächen, von denen jede einer Dialogseite entspricht. Dies kann verwendet werden, um eine Oberfläche mit Registern zu emulieren, indem Schaltflächen nebeneinander im Dialog platziert werden.

- Schaltflächen Vorherige/Nächste: definiert, welche Schaltflächen im Dialog verwendet werden, um zur vorherigen/nächsten Seite im Dialog zu navigieren.

Es ist möglich, mehr als einen Seitenverwaltungsmechanismus gleichzeitig zu verwenden.

Diese Methode sollte nur einmal aufgerufen werden, bevor die Methode Execute aufgerufen wird. Nachfolgende Aufrufe werden ignoriert.

Bei Erfolg gibt diese Methode True zurück.

### Syntax:

svc.SetPageManager(pilotcontrols: str = "", tabcontrols: str = "", wizardcontrols: str = "", opt lastpage: int): bool

### Parameter:

pilotcontrols: eine durch Kommas getrennte Liste von Steuerelementennamen ListBox, ComboBox oder RadioButton, die als Seitenmanager verwendet werden. Legen Sie für Steuerelemente "RadioButton" den Namen des ersten zu verwendenden Steuerelements in der Gruppe fest.

Tabcontrols: eine durch Kommas getrennte Liste von Schaltflächennamen, die als Seitenmanager verwendet werden. Die Reihenfolge, in der sie in diesem Argument angegeben werden, entspricht der Seitenzahl, der sie zugeordnet sind.

wizardcontrols: eine durch Kommas getrennte Liste mit den Namen von zwei Schaltflächen, die als Schaltflächen Zurück/Weiter verwendet werden.

lastpage: die Nummer der letzten verfügbaren Seite. Es wird empfohlen, diesen Wert festzulegen, wenn Sie den Manager für vorherige/nächste Seite verwenden.

### Beispiel:

Stellen Sie sich einen Dialog mit drei Seiten vor. Der Dialog hat ein Steuerelement ListBox namens "aPageList", das verwendet wird, um die sichtbare Seite zu steuern. Zusätzlich gibt es zwei Schaltflächen mit den Namen "btnPrevious" und "btnNext", die als Schaltflächen Zurück/Weiter im Dialog verwendet werden.

##### In Basic

        oDlg.SetPageManager(PilotControls := "aPageList", _
                               WizardControls := "btnPrevious,btnNext", _
                               LastPage := 3)
        oDlg.Execute()

##### In Python

        dlg.SetPageManager(pilotcontrols="aPageList",
                           wizardcontrols="btnPrevious,btnNext",
                           lastpage=3)
        dlg.Execute()

## Terminate

Beendet den Dienst Dialog für die aktuelle Instanz. Gibt True zurück, wenn die Beendigung erfolgreich war.

### Syntax:

svc.Terminate(): bool

### Beispiel:

Die folgenden Basic- und Python-Beispiele öffnen die nicht-modalen Dialoge DlgConsole und dlgTrace. Sie werden jeweils in gemeinsam genutzten Bibliotheken von ScriptForge und Access2Base gespeichert. Schaltflächen zum Schließen von Dialogen sind deaktiviert und eine explizite Beendigung wird am Ende eines laufenden Prozesses durchgeführt.

In diesem Beispiel ersetzt eine Schaltfläche in DlgConsole das gesperrte Schließen des Fensters:

##### In Basic

         oDlg = CreateScriptService("SFDialogs.Dialog","GlobalScope","ScriptForge","DlgConsole")
         oDlg.Execute(modal:=False)
         Wait 5000
         oDlg.Terminate()

##### In Python

         from time import sleep
         dlg = CreateScriptService('SFDialogs.Dialog',"GlobalScope",'Access2Base',"dlgTrace")
         dlg.Execute(modal=False)
         sleep 5
         dlg.Terminate()

Alle ScriptForge Basic-Routinen oder Bezeichner, denen ein Unterstrich "_" vorangestellt ist, sind für den internen Gebrauch reserviert. Sie sind nicht für die Verwendung in Basic-Makros oder Python-Skripten vorgesehen.

Verwandte Themen

Dienst SFDialogs.DialogControl

Dienst ScriptForge.UI